<?php

/**
 * notifica_medida actions.
 *
 * @package    cobro_coactivo
 * @subpackage notifica_medida
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class notifica_medidaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_NOTIFICA_MEDIDA',
        'CBR_LEVANTA_MEDIDA',
        'CBR_MEDIDA_CAUTELAR',
        'CBR_PROCESO_COACTIVO',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_TIPO_NOTIFICA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_LEVANTA_MEDIDA' =>
        array(
            'id_levanta_medida' => 'CBR_NOTIFICA_MEDIDA'
        ),
        'CBR_MEDIDA_CAUTELAR' =>
        array(
            'id_medida_cautelar' => 'CBR_LEVANTA_MEDIDA'
        )/*,
        'CBR_PROCESO_COACTIVO' =>
        array(
            'id_proceso_coactivo' => 'CBR_MEDIDA_CAUTELAR'
        )*/,
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_MEDIDA_CAUTELAR'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TIPO_NOTIFICA' =>
        array(
            'id_tipo_notifica' => 'CBR_NOTIFICA_MEDIDA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_NOTIFICA_MEDIDA' =>
        array(
            'id_notifica_medida' => 'id_notifica_medida',
            'numero' => 'numero',
            'fecha' => 'fecha',
            'adjunto' => 'adjunto',
            'observaciones' => 'observaciones',
            'id_levanta_medida' => 'id_levanta_medida',
            'id_tipo_notifica' => 'id_tipo_notifica',
            'notificado' => 'notificado'
        ),
        'CBR_LEVANTA_MEDIDA' =>
        array(
            'id_medida_cautelar' => 'id_medida_cautelar',
            'no_auto' => 'auto_levanta'
        ),
        'CBR_MEDIDA_CAUTELAR' =>
        array(
            //'id_proceso_coactivo' => 'id_proceso_coactivo',
            'no_auto' => 'auto_medida'
        )/*,
        'CBR_PROCESO_COACTIVO' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha_coactivo',
            'id_anhos' => 'id_anhos'
        )*/,
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        ),
        'CBR_TIPO_NOTIFICA' =>
        array(
            'descripcion' => 'tipo_notifica'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_NOTIFICA_MEDIDA' =>
        array(
            'id_notifica_medida,a' => array('!=' => array(-1)),
            'id_notifica_medida,b' => array('=' => array('id_notifica_medida')),
            'id_medida_cautelar' => array('=' => array('id_medida_cautelar')),
            'id_tipo_notifica' => array('=' => array('id_tipo_notifica')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_notifica_medida'; //identificador de la tabla
    protected $id_names = array('id_notifica_medida'); //llave primaria
    protected $field_names = array('id_levanta_medida', 'id_tipo_notifica', 'numero', 'fecha', 'observaciones', 'adjunto', 'notificado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_NOTIFICA_MEDIDA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_notifica_medida'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        $id_notifica_medida =$list_data_post[0]['id_notifica_medida'];
        if ($Action == "ADD") {
            $this->envioNotificacion($request, $id_notifica_medida);
            
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }
    
     /**
     * Correo de notificacion de notificar avoca - 20200309
     * 
     * @param type $request
     * @param type $id_filtro
     */
    public function envioNotificacion($request, $id_filtro) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a envioNotificacion");

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        $correoEnvio = "";
        $service_url = "";
        foreach ($array as $routeName => $routeData) {
            if ('service_url' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('correoEnvio' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $correoEnvio = $value;
                    }
                }
            }
            $int++;
        }

        /**
         * Envio de correo - 20190911
         */
        $logger->info("Envio de correo inicio ");

        //URL de servicio correo
        $url = $service_url . "curl_envio_correo/list.json";

        $comando = $request['comando'];
        $id_username = $request['id_username'];
        $username = $request['username'];

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CBR_NOTIFICA_MEDIDA');

        //Sql
        $sql = <<<EOD
select 
                
usu.username,
'$comando' as comando,               
avoc.id_medida_cautelar as id_tabla,
'$id_mae_bd' as id_mae_bd,
'$id_username' as id_username,
                
avoc.id_medida_cautelar,
avoc.no_auto,
remi.numero_remision,
remi.anho_remision as id_anhos,
remi.cod_titulo,
ter.id_tipo_doc,
ter.num_doc,
ter.razon_soc,
abo.email as correo,
'$correoEnvio' as email_envio,
'' as mensaje_extra,
'' as mensaje_firma,
'Se realiza la '|| case when notavoc.notificado = 1 then 'solicitud de aprobar' else 'devolución del' end ||' levantamiento de la medida cautelar registo '|| tipdoc.descripcion || ' del titulo minero ' || remi.cod_titulo  || ', verificar recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision 
    || ', se envia por observaciones: '|| notavoc.observaciones as mensaje,
case when notavoc.notificado = 1 then 'Solicitud Aprob ' else 'Devuelto Abog ' end || ' levantamiento de la medida cautelar - Recepcion No.'|| remi.numero_remision || '-' || remi.anho_remision || ' del Titulo: ' || remi.cod_titulo as subject,                        
                
--datos de envio
case when notavoc.notificado = 0 then ter.num_doc else ter.num_doc end as num_doc_env,
case when notavoc.notificado = 0 then ter.id_tipo_doc else ter.id_tipo_doc end as id_tipo_doc_env,
case when notavoc.notificado = 0 then ter.razon_soc else ter.razon_soc end as razon_social_env,
case when notavoc.notificado = 0 then abo.email else usuaprob.email end as correo_env,

--datos de envio usuario
usu.num_doc as num_doc_usu,
usu.id_tipo_doc as id_tipo_doc_usu,
usu.nombre || ' ' || usu.nombre as razon_social_usu,
usu.email as correo_usu

from cbr_notifica_medida notavoc

left join cbr_levanta_medida avocc
on notavoc.id_levanta_medida = avocc.id_levanta_medida

left join cbr_medida_cautelar avoc
on avocc.id_medida_cautelar = avoc.id_medida_cautelar

left join cbr_tipo_documento tipdoc
on tipdoc.id_tipo_documento = 3

left join cbr_reparto repa
on repa.id_remision_titulo = avoc.id_remision_titulo

left join cbr_remision_titulo remi
on avoc.id_remision_titulo = remi.id_remision_titulo

left join cbr_abogado abo
on abo.id_abogado = repa.id_abogado

left join interceros_v ter
on ter.id_mae_ter = abo.id_mae_ter

left join cbr_aprob_deneg_ult_v aprob
on aprob.id_remision_titulo = avoc.id_remision_titulo

left join interceros_v teraprob
on teraprob.id_mae_ter = aprob.usuario_log

left join usuario usuaprob
on usuaprob.num_doc = teraprob.num_doc

left join usuario usu
on usu.username = '$username'

where 1=1
and notavoc.id_notifica_medida = $id_filtro
and repa.estado = 1  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        $this->logMessage("Envio correo");

        if (count($records) > 0) {

            /**
             * Datos de envio
             *
              $params = array(
              'user_from' => 'webservice',
              'recipients' => $recipients,
              'asunto' => 'Error webservie_sigm_consulta',
              'body' => $body
              );
             * 
             */
            $record = $records[0];

            foreach ($record as $key => $value) {
                $params[$key] = $value;
            }

            $params['correo_usu'] = null;

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }
        }

        $logger->info("Envio de correo fin");
    }
   
    
    

}
